/* A Bison parser, made by GNU Bison 1.875a.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     BANKS = 258,
     CHECKSUMS = 259,
     ENTRIES = 260,
     REGIONS = 261,
     ENUMS = 262,
     ID = 263,
     ADDRESS_PORT = 264,
     DATA_PORT = 265,
     LENGTH = 266,
     NUM = 267,
     BANK = 268,
     START = 269,
     TYPE = 270,
     SINGLE_BYTE = 271,
     LOW_FIRST = 272,
     HIGH_FIRST = 273,
     ENUM_ID = 274,
     CHECKSUM = 275,
     RESERVED = 276,
     NUMERIC = 277,
     ENUM = 278,
     STRING = 279,
     VENDOR = 280,
     COMPATIBLE = 281,
     VERSION = 282,
     DATE = 283
   };
#endif
#define BANKS 258
#define CHECKSUMS 259
#define ENTRIES 260
#define REGIONS 261
#define ENUMS 262
#define ID 263
#define ADDRESS_PORT 264
#define DATA_PORT 265
#define LENGTH 266
#define NUM 267
#define BANK 268
#define START 269
#define TYPE 270
#define SINGLE_BYTE 271
#define LOW_FIRST 272
#define HIGH_FIRST 273
#define ENUM_ID 274
#define CHECKSUM 275
#define RESERVED 276
#define NUMERIC 277
#define ENUM 278
#define STRING 279
#define VENDOR 280
#define COMPATIBLE 281
#define VERSION 282
#define DATE 283




/* Copy the first part of user declarations.  */
#line 1 "layoutgrm.y"


/* This file is free software; you can redistribute it and/or modify */
/* it under the terms of the GNU General Public License as published by */
/* the Free Software Foundation; either version 2, or (at your option) */
/* any later version. */

/* This file is distributed in the hope that it will be useful, */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the */
/* GNU General Public License for more details. */

/* You should have received a copy of the GNU General Public License */
/* along with GNU Emacs; see the file COPYING.  If not, write to */
/* the Free Software Foundation, Inc., 59 Temple Place - Suite 330, */
/* Boston, MA 02111-1307, USA. */

/* Copyright (C) 2004 California Digital Corporation */
/* $Id: layoutgrm.y,v 1.7 2004/04/29 22:51:19 summerisle Exp $ */

#include "layoutlex.h"
#include "object.h"

#ifdef HAVE_ERROR_H
#include <error.h>
#endif

#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <sys/types.h>

static void yyerror (char const *s);

#define YYLEX_PARAM scanner
#define YYPARSE_PARAM scanner

static void*
xalloc (size_t size)
{
  void* p;

  p = malloc (size);
  if (!p) error (1, errno, "xalloc");
  return p;
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 94 "layoutgrm.y"
typedef union YYSTYPE {
  long num;
  ident_t* ident;
  enumeration_t* enums;
  enum_value_t* values;
  bank_t* banks;
  region_t* regions;
  entry_type_t entrytype;
  checksum_type_t checksumtype;
  checksum_t* checksums;
  cmentry_t* entries;
  backpatch_t* backpatches;
  layout_t* layoutp;
  char* str;
  bios_info_t* info;
} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 198 "layoutgrm.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 210 "layoutgrm.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   174

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  19
/* YYNRULES -- Number of rules. */
#define YYNRULES  56
/* YYNRULES -- Number of states. */
#define YYNSTATES  182

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   283

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      33,    34,     2,     2,    35,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,    32,
       2,    31,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    29,     2,    30,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     7,     9,    17,    25,    33,    41,    49,
      57,    59,    67,    69,    75,    81,    87,    89,    97,    99,
     105,   111,   117,   119,   121,   123,   125,   133,   135,   141,
     147,   153,   159,   165,   171,   179,   181,   185,   187,   189,
     191,   193,   201,   203,   209,   215,   221,   223,   231,   233,
     239,   241,   249,   251,   257,   263,   269
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      37,     0,    -1,    29,    38,    30,    -1,    54,    -1,    38,
      26,    31,    29,    39,    30,    32,    -1,    38,     3,    31,
      29,    52,    30,    32,    -1,    38,     4,    31,    29,    41,
      30,    32,    -1,    38,     5,    31,    29,    44,    30,    32,
      -1,    38,     6,    31,    29,    48,    30,    32,    -1,    38,
       7,    31,    29,    50,    30,    32,    -1,    54,    -1,    39,
       8,    31,    29,    40,    30,    32,    -1,    54,    -1,    40,
      25,    31,    24,    32,    -1,    40,    27,    31,    24,    32,
      -1,    40,    28,    31,    24,    32,    -1,    54,    -1,    41,
       8,    31,    29,    42,    30,    32,    -1,    54,    -1,    42,
      13,    31,     8,    32,    -1,    42,    14,    31,    12,    32,
      -1,    42,    15,    31,    43,    32,    -1,    16,    -1,    17,
      -1,    18,    -1,    54,    -1,    44,     8,    31,    29,    45,
      30,    32,    -1,    54,    -1,    45,    13,    31,     8,    32,
      -1,    45,    14,    31,    12,    32,    -1,    45,    11,    31,
      12,    32,    -1,    45,    15,    31,    47,    32,    -1,    45,
      19,    31,     8,    32,    -1,    45,    20,    31,     8,    32,
      -1,    45,     4,    31,    33,    46,    34,    32,    -1,     8,
      -1,    46,    35,     8,    -1,    21,    -1,    22,    -1,    23,
      -1,    54,    -1,    48,     8,    31,    29,    49,    30,    32,
      -1,    54,    -1,    49,    13,    31,     8,    32,    -1,    49,
      14,    31,    12,    32,    -1,    49,    11,    31,    12,    32,
      -1,    54,    -1,    50,     8,    31,    29,    51,    30,    32,
      -1,    54,    -1,    51,     8,    31,    12,    32,    -1,    54,
      -1,    52,     8,    31,    29,    53,    30,    32,    -1,    54,
      -1,    53,     9,    31,    12,    32,    -1,    53,    10,    31,
      12,    32,    -1,    53,    11,    31,    12,    32,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   116,   116,   123,   136,   144,   152,   160,   168,   176,
     187,   191,   203,   213,   221,   229,   240,   244,   256,   268,
     276,   284,   295,   299,   303,   310,   314,   326,   341,   349,
     357,   365,   373,   381,   394,   405,   415,   428,   432,   436,
     443,   447,   459,   470,   478,   486,   497,   501,   514,   518,
     531,   535,   547,   557,   565,   573,   583
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "BANKS", "CHECKSUMS", "ENTRIES", "REGIONS", 
  "ENUMS", "ID", "ADDRESS_PORT", "DATA_PORT", "LENGTH", "NUM", "BANK", 
  "START", "TYPE", "SINGLE_BYTE", "LOW_FIRST", "HIGH_FIRST", "ENUM_ID", 
  "CHECKSUM", "RESERVED", "NUMERIC", "ENUM", "STRING", "VENDOR", 
  "COMPATIBLE", "VERSION", "DATE", "'{'", "'}'", "'='", "';'", "'('", 
  "')'", "','", "$accept", "layout", "sections", "compatibles", "info", 
  "checksums", "checksum_attribs", "checksum_type", "entries", 
  "entry_attribs", "ids", "entry_type", "regions", "region_attribs", 
  "enums", "enum_attribs", "banks", "bank_attribs", "empty", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   123,
     125,    61,    59,    40,    41,    44
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    36,    37,    38,    38,    38,    38,    38,    38,    38,
      39,    39,    40,    40,    40,    40,    41,    41,    42,    42,
      42,    42,    43,    43,    43,    44,    44,    45,    45,    45,
      45,    45,    45,    45,    45,    46,    46,    47,    47,    47,
      48,    48,    49,    49,    49,    49,    50,    50,    51,    51,
      52,    52,    53,    53,    53,    53,    54
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     3,     1,     7,     7,     7,     7,     7,     7,
       1,     7,     1,     5,     5,     5,     1,     7,     1,     5,
       5,     5,     1,     1,     1,     1,     7,     1,     5,     5,
       5,     5,     5,     5,     7,     1,     3,     1,     1,     1,
       1,     7,     1,     5,     5,     5,     1,     7,     1,     5,
       1,     7,     1,     5,     5,     5,     0
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,    56,     0,     0,     3,     1,     0,     0,     0,     0,
       0,     0,     2,     0,     0,     0,     0,     0,     0,    56,
      56,    56,    56,    56,    56,     0,    50,     0,    16,     0,
      25,     0,    40,     0,    46,     0,    10,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       5,     0,     6,     0,     7,     0,     8,     0,     9,     0,
       4,    56,    56,    56,    56,    56,    56,     0,    52,     0,
      18,     0,    27,     0,    42,     0,    48,     0,    12,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    51,     0,
       0,     0,    17,     0,     0,     0,     0,     0,     0,     0,
      26,     0,     0,     0,    41,     0,    47,     0,     0,     0,
      11,     0,     0,     0,     0,     0,    22,    23,    24,     0,
       0,     0,     0,     0,    37,    38,    39,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    53,    54,    55,
      19,    20,    21,    35,     0,    30,    28,    29,    31,    32,
      33,    45,    43,    44,    49,    13,    14,    15,     0,     0,
      34,    36
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     2,     3,    35,    77,    27,    69,   139,    29,    71,
     164,   147,    31,    73,    33,    75,    25,    67,     4
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -20
static const short yypact[] =
{
     -14,   -20,    53,     3,   -20,   -20,    26,    29,    37,    38,
      39,    42,   -20,    43,    45,    47,    48,    49,    50,   -20,
     -20,   -20,   -20,   -20,   -20,     4,   -20,     5,   -20,     6,
     -20,     8,   -20,     9,   -20,    11,   -20,    51,    52,    54,
      55,    57,    58,    60,    61,    63,    64,    66,    67,    69,
     -20,    71,   -20,    72,   -20,    73,   -20,    74,   -20,    75,
     -20,   -20,   -20,   -20,   -20,   -20,   -20,    21,   -20,    10,
     -20,     7,   -20,    41,   -20,    20,   -20,    31,   -20,    76,
      77,    78,    79,    81,    82,    83,    84,    86,    87,    88,
      89,    90,    91,    92,    93,    95,    96,    97,    98,   100,
     101,   103,   104,   105,   106,    68,    80,    94,   -20,   102,
     112,    46,   -20,    56,   117,   107,   120,    44,   129,   131,
     -20,   128,   133,   130,   -20,   132,   -20,    59,    62,   119,
     -20,   113,   114,   115,   116,   118,   -20,   -20,   -20,   121,
     141,   122,   123,   124,   -20,   -20,   -20,   125,   126,   127,
     134,   135,   136,   137,   138,   139,   140,   -20,   -20,   -20,
     -20,   -20,   -20,   -20,    14,   -20,   -20,   -20,   -20,   -20,
     -20,   -20,   -20,   -20,   -20,   -20,   -20,   -20,   142,   143,
     -20,   -20
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -20,   -20,   -20,   -20,   -20,   -20,   -20,   -20,   -20,   -20,
     -20,   -20,   -20,   -20,   -20,   -20,   -20,   -20,   -19
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      26,    28,    30,    32,    34,    36,     6,     7,     8,     9,
      10,    87,    37,    39,    41,     1,    43,    45,    88,    47,
      89,    90,    91,    83,    84,    85,    92,    93,    99,    11,
      79,    80,    81,    12,    38,    40,    42,    94,    44,    46,
      86,    48,    68,    70,    72,    74,    76,    78,   178,   179,
     100,    82,    95,     5,    96,    97,   101,    13,   102,   103,
      14,   104,   136,   137,   138,   144,   145,   146,    15,    16,
      17,    98,    19,    18,    20,     0,    21,    22,    23,    24,
     131,     0,    49,   154,    50,    51,   155,    52,    53,   140,
      54,    55,   132,    56,    57,     0,    58,    59,    61,    60,
      62,    63,    64,    65,    66,     0,   133,   105,   106,   107,
     134,   108,   109,   110,   111,   142,   112,   113,   114,   115,
     116,   117,   118,   119,   135,   120,   121,   122,   123,   141,
     124,   125,   143,   126,   127,   128,   129,   148,   130,   149,
     150,   151,   152,   156,   153,   157,   158,   159,   160,   163,
     161,   181,     0,   162,   165,   166,   167,   168,   169,   170,
       0,     0,     0,     0,     0,     0,   171,   172,   173,   174,
     175,   176,   177,     0,   180
};

static const yysigned_char yycheck[] =
{
      19,    20,    21,    22,    23,    24,     3,     4,     5,     6,
       7,     4,     8,     8,     8,    29,     8,     8,    11,     8,
      13,    14,    15,    13,    14,    15,    19,    20,     8,    26,
       9,    10,    11,    30,    30,    30,    30,    30,    30,    30,
      30,    30,    61,    62,    63,    64,    65,    66,    34,    35,
      30,    30,    11,     0,    13,    14,    25,    31,    27,    28,
      31,    30,    16,    17,    18,    21,    22,    23,    31,    31,
      31,    30,    29,    31,    29,    -1,    29,    29,    29,    29,
      12,    -1,    31,    24,    32,    31,    24,    32,    31,    33,
      32,    31,    12,    32,    31,    -1,    32,    31,    29,    32,
      29,    29,    29,    29,    29,    -1,    12,    31,    31,    31,
       8,    32,    31,    31,    31,     8,    32,    31,    31,    31,
      31,    31,    31,    31,    12,    32,    31,    31,    31,    12,
      32,    31,    12,    32,    31,    31,    31,     8,    32,     8,
      12,     8,    12,    24,    12,    32,    32,    32,    32,     8,
      32,     8,    -1,    32,    32,    32,    32,    32,    32,    32,
      -1,    -1,    -1,    -1,    -1,    -1,    32,    32,    32,    32,
      32,    32,    32,    -1,    32
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    29,    37,    38,    54,     0,     3,     4,     5,     6,
       7,    26,    30,    31,    31,    31,    31,    31,    31,    29,
      29,    29,    29,    29,    29,    52,    54,    41,    54,    44,
      54,    48,    54,    50,    54,    39,    54,     8,    30,     8,
      30,     8,    30,     8,    30,     8,    30,     8,    30,    31,
      32,    31,    32,    31,    32,    31,    32,    31,    32,    31,
      32,    29,    29,    29,    29,    29,    29,    53,    54,    42,
      54,    45,    54,    49,    54,    51,    54,    40,    54,     9,
      10,    11,    30,    13,    14,    15,    30,     4,    11,    13,
      14,    15,    19,    20,    30,    11,    13,    14,    30,     8,
      30,    25,    27,    28,    30,    31,    31,    31,    32,    31,
      31,    31,    32,    31,    31,    31,    31,    31,    31,    31,
      32,    31,    31,    31,    32,    31,    32,    31,    31,    31,
      32,    12,    12,    12,     8,    12,    16,    17,    18,    43,
      33,    12,     8,    12,    21,    22,    23,    47,     8,     8,
      12,     8,    12,    12,    24,    24,    24,    32,    32,    32,
      32,    32,    32,     8,    46,    32,    32,    32,    32,    32,
      32,    32,    32,    32,    32,    32,    32,    32,    34,    35,
      32,     8
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 117 "layoutgrm.y"
    {
  (*((input_state_t**)scanner))->result_layout = yyvsp[-1].layoutp;
;}
    break;

  case 3:
#line 124 "layoutgrm.y"
    {
  layout_t* l;

  l = xalloc (sizeof (layout_t));
  l->compat = NULL;
  l->banks = NULL;
  l->checksums = NULL;
  l->entries = NULL;
  l->regions = NULL;
  l->enums = NULL;
  yyval.layoutp = l;
;}
    break;

  case 4:
#line 137 "layoutgrm.y"
    {
  layout_t* l;

  l = yyvsp[-6].layoutp;
  l->compat = yyvsp[-2].info;
  yyval.layoutp = l;
;}
    break;

  case 5:
#line 145 "layoutgrm.y"
    {
  layout_t* l;

  l = yyvsp[-6].layoutp;
  l->banks = yyvsp[-2].banks;
  yyval.layoutp = l;
;}
    break;

  case 6:
#line 153 "layoutgrm.y"
    {
  layout_t* l;

  l = yyvsp[-6].layoutp;
  l->checksums = yyvsp[-2].checksums;
  yyval.layoutp = l;
;}
    break;

  case 7:
#line 161 "layoutgrm.y"
    {
  layout_t* l;

  l = yyvsp[-6].layoutp;
  l->entries = yyvsp[-2].entries;
  yyval.layoutp = l;
;}
    break;

  case 8:
#line 169 "layoutgrm.y"
    {
  layout_t* l;

  l = yyvsp[-6].layoutp;
  l->regions = yyvsp[-2].regions;
  yyval.layoutp = l;
;}
    break;

  case 9:
#line 177 "layoutgrm.y"
    {
  layout_t* l;

  l = yyvsp[-6].layoutp;
  l->enums = yyvsp[-2].enums;
  yyval.layoutp = l;
;}
    break;

  case 10:
#line 188 "layoutgrm.y"
    {
  yyval.info = NULL;
;}
    break;

  case 11:
#line 192 "layoutgrm.y"
    {
  bios_info_t* c;

  c = yyvsp[-2].info;
  c->next = yyvsp[-6].info;
  c->name = yyvsp[-5].ident;
  yyval.info = c;
;}
    break;

  case 12:
#line 204 "layoutgrm.y"
    {
  bios_info_t* bi;

  bi = xalloc (sizeof(bios_info_t));
  bi->vendor = NULL;
  bi->version = NULL;
  bi->date = NULL;
  yyval.info = bi;
;}
    break;

  case 13:
#line 214 "layoutgrm.y"
    {
  bios_info_t* bi;

  bi = yyvsp[-4].info;
  bi->vendor = yyvsp[-1].str;
  yyval.info = bi;
;}
    break;

  case 14:
#line 222 "layoutgrm.y"
    {
  bios_info_t* bi;

  bi = yyvsp[-4].info;
  bi->version = yyvsp[-1].str;
  yyval.info = bi;
;}
    break;

  case 15:
#line 230 "layoutgrm.y"
    {
  bios_info_t* bi;

  bi = yyvsp[-4].info;
  bi->date = yyvsp[-1].str;
  yyval.info = bi;
;}
    break;

  case 16:
#line 241 "layoutgrm.y"
    {
  yyval.checksums = NULL;
;}
    break;

  case 17:
#line 245 "layoutgrm.y"
    {
  checksum_t* c;

  c = yyvsp[-2].checksums;
  c->next = yyvsp[-6].checksums;
  c->name = yyvsp[-5].ident;
  yyval.checksums = c;
;}
    break;

  case 18:
#line 257 "layoutgrm.y"
    {
  checksum_t* c;

  c = xalloc (sizeof (checksum_t));
  c->next = NULL;
  c->bp_bank.filled = 0;
  c->bp_bank.u.name = NULL;
  c->type = ct_none;
  c->start = -1;
  yyval.checksums = c;
;}
    break;

  case 19:
#line 269 "layoutgrm.y"
    {
  checksum_t* c;

  c = yyvsp[-4].checksums;
  c->bp_bank.u.name = yyvsp[-1].ident;
  yyval.checksums = c;
;}
    break;

  case 20:
#line 277 "layoutgrm.y"
    {
  checksum_t* c;

  c = yyvsp[-4].checksums;
  c->start = yyvsp[-1].num;
  yyval.checksums = c;
;}
    break;

  case 21:
#line 285 "layoutgrm.y"
    {
  checksum_t* c;

  c = yyvsp[-4].checksums;
  c->type = yyvsp[-1].checksumtype;
  yyval.checksums = c;
;}
    break;

  case 22:
#line 296 "layoutgrm.y"
    {
  yyval.checksumtype = single_byte;
;}
    break;

  case 23:
#line 300 "layoutgrm.y"
    {
  yyval.checksumtype = low_first;
;}
    break;

  case 24:
#line 304 "layoutgrm.y"
    {
  yyval.checksumtype = high_first;
;}
    break;

  case 25:
#line 311 "layoutgrm.y"
    {
  yyval.entries = NULL;
;}
    break;

  case 26:
#line 315 "layoutgrm.y"
    {
  cmentry_t* e;

  e = yyvsp[-2].entries;
  e->next = yyvsp[-6].entries;
  e->name = yyvsp[-5].ident;
  yyval.entries = e;
;}
    break;

  case 27:
#line 327 "layoutgrm.y"
    {
  cmentry_t* e;

  e = xalloc (sizeof (cmentry_t));
  e->bp_bank.filled = 0;
  e->bp_bank.u.name = NULL;
  e->start_bit = e->bit_length = -1;
  e->type = et_none;
  e->bp_enum.filled = 0;
  e->bp_enum.u.name = NULL;
  e->pbp_checksums = NULL;
  e->next = NULL;
  yyval.entries = e;
;}
    break;

  case 28:
#line 342 "layoutgrm.y"
    {
  cmentry_t* e;

  e = yyvsp[-4].entries;
  e->bp_bank.u.name = yyvsp[-1].ident;
  yyval.entries = e;
;}
    break;

  case 29:
#line 350 "layoutgrm.y"
    {
  cmentry_t* e;

  e = yyvsp[-4].entries;
  e->start_bit = yyvsp[-1].num;
  yyval.entries = e;
;}
    break;

  case 30:
#line 358 "layoutgrm.y"
    {
  cmentry_t* e;

  e = yyvsp[-4].entries;
  e->bit_length = yyvsp[-1].num;
  yyval.entries = e;
;}
    break;

  case 31:
#line 366 "layoutgrm.y"
    {
  cmentry_t* e;

  e = yyvsp[-4].entries;
  e->type = yyvsp[-1].entrytype;
  yyval.entries = e;
;}
    break;

  case 32:
#line 374 "layoutgrm.y"
    {
  cmentry_t* e;

  e = yyvsp[-4].entries;
  e->bp_enum.u.name = yyvsp[-1].ident;
  yyval.entries = e;
;}
    break;

  case 33:
#line 382 "layoutgrm.y"
    {
  cmentry_t* e;
  backpatch_t* pbp;
  
  e = yyvsp[-4].entries;
  pbp = xalloc (sizeof (backpatch_t));
  pbp->filled = 0;
  pbp->u.name = yyvsp[-1].ident;
  pbp->next = NULL;
  e->pbp_checksums = pbp;
  yyval.entries = e;
;}
    break;

  case 34:
#line 395 "layoutgrm.y"
    {
  cmentry_t* e;

  e = yyvsp[-6].entries;
  e->pbp_checksums = yyvsp[-2].backpatches;
  yyval.entries = e;
;}
    break;

  case 35:
#line 406 "layoutgrm.y"
    {
  backpatch_t* pbp;

  pbp = xalloc (sizeof (backpatch_t));
  pbp->filled = 0;
  pbp->u.name = yyvsp[0].ident;
  pbp->next = NULL;
  yyval.backpatches = pbp;
;}
    break;

  case 36:
#line 416 "layoutgrm.y"
    {
  backpatch_t* pbp;

  pbp = xalloc (sizeof (backpatch_t));
  pbp->filled = 0;
  pbp->u.name = yyvsp[0].ident;
  pbp->next = yyvsp[-2].backpatches;
  yyval.backpatches = pbp;
;}
    break;

  case 37:
#line 429 "layoutgrm.y"
    {
  yyval.entrytype = reserved;
;}
    break;

  case 38:
#line 433 "layoutgrm.y"
    {
  yyval.entrytype = numeric;
;}
    break;

  case 39:
#line 437 "layoutgrm.y"
    {
  yyval.entrytype = enumtype;
;}
    break;

  case 40:
#line 444 "layoutgrm.y"
    {
  yyval.regions = NULL;
;}
    break;

  case 41:
#line 448 "layoutgrm.y"
    {
  region_t* r;

  r = yyvsp[-2].regions;
  r->next = yyvsp[-6].regions;
  r->name = yyvsp[-5].ident;
  yyval.regions = r;
;}
    break;

  case 42:
#line 460 "layoutgrm.y"
    {
  region_t* r;

  r = xalloc (sizeof (region_t));
  r->bp_bank.filled = 0;
  r->bp_bank.u.name = 0;
  r->start_byte = r->byte_length = -1;
  r->next = NULL;
  yyval.regions = r;
;}
    break;

  case 43:
#line 471 "layoutgrm.y"
    {
  region_t* r;

  r = yyvsp[-4].regions;
  r->bp_bank.u.name = yyvsp[-1].ident;
  yyval.regions = r;
;}
    break;

  case 44:
#line 479 "layoutgrm.y"
    {
  region_t* r;

  r = yyvsp[-4].regions;
  r->start_byte = yyvsp[-1].num;
  yyval.regions = r;
;}
    break;

  case 45:
#line 487 "layoutgrm.y"
    {
  region_t* r;

  r = yyvsp[-4].regions;
  r->byte_length = yyvsp[-1].num;
  yyval.regions = r;
;}
    break;

  case 46:
#line 498 "layoutgrm.y"
    {
  yyval.enums = NULL;
;}
    break;

  case 47:
#line 502 "layoutgrm.y"
    {
  enumeration_t* e;

  e = xalloc (sizeof (enumeration_t));
  e->next = yyvsp[-6].enums;
  e->name = yyvsp[-5].ident;
  e->values = yyvsp[-2].values;
  yyval.enums = e;
;}
    break;

  case 48:
#line 515 "layoutgrm.y"
    {
  yyval.values = NULL;
;}
    break;

  case 49:
#line 519 "layoutgrm.y"
    {
  enum_value_t* v;
  
  v = xalloc (sizeof (enum_value_t));
  v->next = yyvsp[-4].values;
  v->name = yyvsp[-3].ident;
  v->value = yyvsp[-1].num;
  yyval.values = v;
;}
    break;

  case 50:
#line 532 "layoutgrm.y"
    {
  yyval.banks = NULL;
;}
    break;

  case 51:
#line 536 "layoutgrm.y"
    {
  bank_t* b;

  b = yyvsp[-2].banks;
  b->next = yyvsp[-6].banks;
  b->name = yyvsp[-5].ident;
  yyval.banks = b;
;}
    break;

  case 52:
#line 548 "layoutgrm.y"
    {
  bank_t* b;

  b = xalloc (sizeof (bank_t));
  b->address_port = b->data_port = 0xffff;
  b->length = -1;
  b->next = NULL;
  yyval.banks = b;
;}
    break;

  case 53:
#line 558 "layoutgrm.y"
    {
  bank_t* b;

  b = yyvsp[-4].banks;
  b->address_port = yyvsp[-1].num;
  yyval.banks = b;
;}
    break;

  case 54:
#line 566 "layoutgrm.y"
    {
  bank_t* b;

  b = yyvsp[-4].banks;
  b->data_port = yyvsp[-1].num;
  yyval.banks = b;
;}
    break;

  case 55:
#line 574 "layoutgrm.y"
    {
  bank_t* b;

  b = yyvsp[-4].banks;
  b->length = yyvsp[-1].num;
  yyval.banks = b;
;}
    break;


    }

/* Line 999 of yacc.c.  */
#line 1799 "layoutgrm.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 586 "layoutgrm.y"


void
yyerror (char const *s)
{
  fprintf (stderr, "%s\n", s);
}

